.TH libinput-list-devices "1" "" "libinput @LIBINPUT_VERSION@" "libinput Manual"
.SH NAME
libinput\-list\-devices \- list local devices as recognized by libinput and
default values of their configuration
.SH SYNOPSIS
.B libinput list\-devices [\-\-help]
.SH DESCRIPTION
.PP
The
.B "libinput list\-devices"
tool creates a libinput context on the default seat "seat0" and lists all
devices recognized by libinput. Each device shows available configurations
the respective default configuration setting.
.PP
For options that allow more settings than "enabled/disabled", all available ones
are listed. The default setting is prefixed by an asterisk (*).
.PP
This tool usually needs to be run as root to have access to the
/dev/input/eventX nodes.
.SH OPTIONS
.TP 8
.B \-\-help
Print help
.SH NOTES
.PP
Some specific feature may still be available on a device even when
no configuration is exposed, a lack of a configuration option does not
necessarily mean that this feature does not work.
.PP
A device may be recognized by libinput but not handled by the X.Org libinput
driver or the Wayland compositor.
.PP
An xorg.conf(5) configuration entry or Wayland compositor setting may have
changed configurations on a device. The
.B "libinput list\-devices"
tool only shows the device's default configuration, not the current
configuration.
.SH LIBINPUT
Part of the
.B libinput(1)
suite
